%global optflags %{optflags} -Wno-parentheses
%{!?_release_number: %define _release_number 1}
Name:           trust_router
Version:        3.5.2
Release:        %{_release_number}%{?dist}
Summary:        Moonshot Trust Router

Group:          System Environment/Libraries
License:        BSD
URL:            https://github.com/janetuk/trust_router
Source0:        %{name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: autoconf, automake, m4, libtool
BuildRequires:  krb5-devel, glib2-devel
BuildRequires: jansson-devel >= 2.4
BuildRequires: sqlite-devel, openssl-devel, libtalloc-devel

%if 0%{?el6}
BuildRequires: libevent2-devel
%else
BuildRequires: libevent-devel >= 2.0
BuildRequires: systemd
%endif

Requires:       moonshot-gss-eap >= 0.9.3, sqlite

%description
The trust router provides a mechanism for discovering the topology of
trust graphs in a topology and establishing temporary identities
between them.


%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name}-libs = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}-libs.

%package libs
Summary: Libraries needed by %{name}

%description libs
This package includes libraries needed by the %{name} package or
packages that wish trust_router functionality.




%prep
%setup -q
autoreconf -f -i

%build
%configure --disable-static
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

# Install config files
install -D -m 755 redhat/init $RPM_BUILD_ROOT/%{_initrddir}/trust_router
install -D -m 640 redhat/organizations.cfg $RPM_BUILD_ROOT/%{_sysconfdir}/trust_router/organizations.cfg
install -D -m 640 redhat/default-internal.cfg $RPM_BUILD_ROOT/%{_sysconfdir}/trust_router/conf.d/default/internal.cfg
install -D -m 640 redhat/tr-test-internal.cfg $RPM_BUILD_ROOT/%{_sysconfdir}/trust_router/conf.d/tr-test/internal.cfg
install -D -m 640 redhat/sysconfig $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/trust_router
install -D -m 640 redhat/sysconfig.tids $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/tids
install -D -m 755 redhat/tids.init $RPM_BUILD_ROOT/%{_initrddir}/tids

# Overwrite Debian's service file
%if 0%{?rhel} >= 7
install -D -m 755 redhat/tids.service $RPM_BUILD_ROOT/%{_unitdir}/tids.service
%endif

# Link shared config
ln -s ../../organizations.cfg $RPM_BUILD_ROOT/%{_sysconfdir}/trust_router/conf.d/default/organizations.cfg
ln -s ../../organizations.cfg $RPM_BUILD_ROOT/%{_sysconfdir}/trust_router/conf.d/tr-test/organizations.cfg

# Install wrapper scripts
install -D -m 755 redhat/tidc-wrapper $RPM_BUILD_ROOT/%{_bindir}/tidc-wrapper
install -D -m 755 redhat/tids-wrapper $RPM_BUILD_ROOT/%{_bindir}/tids-wrapper
install -D -m 755 redhat/trust_router-wrapper $RPM_BUILD_ROOT/%{_bindir}/trust_router-wrapper

# As we're building an RPM, we don't need the init scripts etc. in /usr/share
rm -rf $RPM_BUILD_ROOT/%{_datadir}/trust_router/redhat


%clean
rm -rf $RPM_BUILD_ROOT


%pre
getent group trustrouter > /dev/null || groupadd -r trustrouter
getent passwd trustrouter > /dev/null || useradd -r -g trustrouter -d /var/lib/trust_router -s /sbin/nologin -c "GSS-EAP Trust Router service account" trustrouter
exit 0


%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%post
# Data directory
tr_home=/var/lib/trust_router
tr_schema=${tr_home}/.schema_1.5.2
test -d ${tr_home} ||mkdir ${tr_home}
chown trustrouter:trustrouter ${tr_home}
test -e $tr_schema || rm -f $tr_home/keys
sqlite3 </usr/share/trust_router/schema.sql ${tr_home}/keys
touch $tr_schema
chown trustrouter:trustrouter ${tr_home}/keys
chmod 660 ${tr_home}/keys


# Log Directory
test -d /var/log/trust_router ||mkdir /var/log/trust_router
chown root:trustrouter /var/log/trust_router
chmod 770 /var/log/trust_router



%files
%defattr(-,root,root,-)
%doc README
#%{_bindir}/tidc
#%{_bindir}/tidc-wrapper
#%{_bindir}/tids
#%{_bindir}/tids-wrapper
#%{_bindir}/trmon
#%{_bindir}/trust_router
#%{_bindir}/trust_router-wrapper
%{_bindir}/*
%{_datadir}/trust_router/schema.sql

%{_initrddir}/tids
%{_initrddir}/trust_router

%if 0%{?rhel} >= 7
%{_unitdir}/tids.service
%{_unitdir}/trust_router.service
%endif

%config(noreplace) %{_sysconfdir}/sysconfig/tids
%config(noreplace) %{_sysconfdir}/sysconfig/trust_router

%dir %attr(755,root,trustrouter) %{_sysconfdir}/trust_router
%dir %attr(755,root,trustrouter) %{_sysconfdir}/trust_router/conf.d/
%dir %attr(755,root,trustrouter) %{_sysconfdir}/trust_router/conf.d/default
%dir %attr(755,root,trustrouter) %{_sysconfdir}/trust_router/conf.d/tr-test

%attr(640,root,trustrouter) %config(noreplace) %{_sysconfdir}/trust_router/organizations.cfg
%attr(640,root,trustrouter) %config(noreplace) %{_sysconfdir}/trust_router/conf.d/default/internal.cfg
%attr(640,root,trustrouter) %config(noreplace) %{_sysconfdir}/trust_router/conf.d/tr-test/internal.cfg
%attr(640,root,trustrouter) %config(noreplace) %{_sysconfdir}/trust_router/conf.d/default/organizations.cfg
%attr(640,root,trustrouter) %config(noreplace) %{_sysconfdir}/trust_router/conf.d/tr-test/organizations.cfg

%files libs
%defattr(-,root,root,-)
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/*.so



%changelog
* Thu Oct 15 2019 Jisc <moonshot@jisc.ac.uk> - 3.5.2
- Add CI for CentOS 8
- Added init scripts for Alpine
- Removed old debian init scripts

* Thu Sep 19 2019 Jisc <moonshot@jisc.ac.uk> - 3.5.1
- Add CI for Alpine 3.9 and Raspbian 10

* Fri Apr 26 2019 Jisc <moonshot@jisc.ac.uk> - 3.5.0
- Add support for IPv6
- Allow tids to receive a list IP addresses to listen from
- Allow constraints to contain multiple '*' and '?' wildcards anywhere

* Wed Mar 20 2019 Jisc <moonshot@jisc.ac.uk> - 3.4.10
- Reorganise some of the "internal" configuration options into groups
- Fix some issues found by the CLANG static analyser
- Add a log message indicating that changes to hostname or ports require
  a restart to take effect.

* Tue Mar 05 2019 Jisc <moonshot@jisc.ac.uk> - 3.4.9
- Fix how default values are set for systemd units

* Mon Mar 04 2019 Jisc <moonshot@jisc.ac.uk> - 3.4.8
- Rework of tids command line arguments and init scripts

* Wed Feb 27 2019 Jisc <moonshot@jisc.ac.uk> - 3.4.7
- Update source URL
- Allow realms to be case insensitive
- Update "tids" so it accepts optional arguments and has sensible
  default values

* Sat Feb 02 2019 Jisc <moonshot@jisc.ac.uk> - 3.4.6
- Build source package

* Tue Jan 22 2019 Jisc <moonshot@jisc.ac.uk> - 3.4.5-0
- Include Build for Debian Buster

* Tue Nov 27 2018 Jisc <moonshot@jisc.ac.uk> - 3.4.4-0
- Improve tidc/tids/trmon command help
- Support OpenSSL 1.1

* Wed Sep 12 2018 Jisc <moonshot@jisc.ac.uk> - 3.4.3-0
- Fix bug making trustrouter server not sending error responses.
- Fix "internal error" caused not finding authorisations.

* Mon Sep 03 2018 Jisc <moonshot@jisc.ac.uk> - 3.4.2-0
- Add trust_router systemd unit
- Fix tids systemd unit

* Tue Jun 05 2018 Jennifer Richards <jennifer@painless-security.com> - 3.4.1-0
- Fix broken libtr_tid shared library
- Link trust_router, tids, and tidc against libtr_tid
- Disentangle TID, TRP, and MON protocols in tr_msg.c and tr_filter.c
- Handle missing monitoring section in internal configuration
- Fix pointer dereferencing error
- Remove duplicated typedefs
- Eliminate compiler warnings
- Update internal.cfg example configuration file

* Tue Jun 05 2018 Jennifer Richards <jennifer@painless-security.com> - 3.4.0-2
- Use json_is_true() in place of json_boolean_value() for compatibility

* Mon Jun 04 2018 Jennifer Richards <jennifer@painless-security.com> - 3.4.0-1
- Add monitoring interface and trmon utility
- Support non-default TID and TRP ports
- Add timeout to GSS buffer reads to prevent hung processes
- Changes to configuration files
  * ports now specified by hostname:port for AAA servers / trust routers
  * "monitoring" section added to internal configuration
- Fix several bugs and memory leaks
- Improved cleanup of terminated subprocesses
- Improvements to logging
- Add a "request_id" to TID requests

* Fri Feb 23 2018 Jennifer Richards <jennifer@painless-security.com> - 3.3.0-1
- Fix segfault when sweeping realms and communities

* Tue Nov 13 2017 Jennifer Richards <jennifer@painless-security.com> - 3.0.3-3
- Use default AAA servers for unrouted realms
- Always return NULL if allocation fails in tr_compute_dh_key
- Improve example config files

* Tue Sep 12 2017 Jennifer Richards <jennifer@painless-security.com> - 3.0.2-2
- Add --no-start option to dh_installinit for TIDS service
- Remove unintended dependency on Jansson in trust_router/tr_name.h
- Load multiple configuration files properly
- Fix memory leak when loading configuration files
- Reduce amount of debug output

* Mon Jun 17 2017 Jennifer Richards <jennifer@painless-security.com> - 3.0.0-5
- Add public accessor for TID_SRVR_BLK's key_expiration

* Fri Jun 14 2017 Jennifer Richards <jennifer@painless-security.com> - 3.0.0-4
- Initialize refcount for IDP realms

* Thu Jun 13 2017 Jennifer Richards <jennifer@painless-security.com> - 3.0.0-3
- Apply filters from all RP clients applicable to a GSS name to a TID request

* Tue Jun 11 2017 Jennifer Richards <jennifer@painless-security.com> - 3.0.0-2
- Fix loop termination condition in trps_filter_outbound_updates()
- Correct the default TID and TRP ports in internal.cfg

* Thu Jun 06 2017 Jennifer Richards <jennifer@painless-security.com> - 3.0.0-1
- New upstream release
- Support full TID and TRP filtering
- Add --version option

* Thu Jan 26 2017 Jennifer Richards <jennifer@painless-security.com> - 2.1.1-1
- New upstream release
- Support community information flooding
- Support support multiple AAA servers for an IdP
- Support IPv6 addressing

* Tue Sep 20 2016 Jennifer Richards <jennifer@painless-security.com> - 2.0-1
- New upstream release
- Support dynamic trust route peering, flooding, and discovery
- Support TID request routing
- New configuration file format

* Wed Mar 25 2015 Sam Hartman <hartmans@debian.org> - 1.5.1.2
- Fix insert statement

* Wed Mar 25 2015 Sam Hartman <hartmans@debian.org> - 1.5.1.1
- New Upstream version to fix key expiration schema/view

* Tue Mar 17 2015 Sam Hartman <hartmans@debian.org> - 1.5.4
- Fix versioning because we want to fix the gss_delete_sec_context for wheezy
- Move logging section to tr_internal

* Tue Mar 17 2015 Sam Hartman <hartmans@debian.org> - 1.5.3
- Pull in expiration fix
- Depend on sufficiently new moonshot-gss-eap to avoid
  delete_sec_context problem

* Fri Mar 13 2015 Sam Hartman <hartmans@debian.org> - 1.5.2
- Fix comparison operator

* Wed Mar 11 2015 Sam Hartman <hartmans@debian.org> - 1.5.1
- New Upstream Release
- Support Key expiration and  logging

* Tue Nov 04 2014 Sam Hartman <hartmans@debian.org> - 1.4.1-2
- Print default realm from Config  (LP: #1386654)

* Tue Oct 07 2014 Sam Hartman <hartmans@debian.org> - 1.4.1-1
- New upstream version
  * Fix major bug in handling of community lookups when defaulting is
    not used.

* Fri Oct 03 2014 Sam Hartman <hartmans@debian.org> - 1.4-9
- Fix lintian errors:
  * Update LSB header for tids init script
  * Make tids wrapper executable
  * Override things lintian gets wrong

* Fri Oct 03 2014 Sam Hartman <hartmans@debian.org> - 1.4-8
- Fix umask of database

* Fri Oct 03 2014 Sam Hartman <hartmans@debian.org> - 1.4-7
- Remove debugging and fix postinst script to work when SHELL is not set.

* Thu Oct 02 2014 Sam Hartman <hartmans@debian.org> - 1.4-6
- Even more debugging

* Thu Oct 02 2014 Sam Hartman <hartmans@debian.org> - 1.4-5
- Even more debugging

* Wed Oct 01 2014 Sam Hartman <hartmans@debian.org> - 1.4-4
- postinst quiet about user creation
- tids.init:fix run levels
- Add debugging to postinst to try and understand dvd creation bug

* Tue Sep 30 2014 Sam Hartman <hartmans@debian.org> - 1.4-3
- Create a schema on upgrade or install

* Tue Sep 30 2014 Sam Hartman <hartmans@debian.org> - 1.4-2
- Update to fix bug in init script, Thanks Stefan

* Fri Sep 26 2014 Sam Hartman <hartmans@debian.org> - 1.4-1
- New Upstream version
- Install tids init script, thanks Stefan Paetow

* Wed Aug 27 2014 Sam Hartman <hartmans@debian.org> - 1.3.1-1
- New Upstream Version
- Initial Debian release, Closes: #759398
- Use git dpm and 3.0 quilt source format

* Tue Jul 22 2014 Sam Hartman <hartmans@debian.org> - 1.3-1
- New upstream version

* Mon May 26 2014 Sam Hartman <hartmans@debian.org> - 1.2-4
- Fix another bug in tids.service

* Wed May 21 2014 Sam Hartman <hartmans@debian.org> - 1.2-3
- trust_router not trustrouter in tids.service

* Mon May 19 2014 Sam Hartman <hartmans@debian.org> - 1.2-2
- Include systemd service and schema file
- Create trustrouter user on install

* Tue Mar 18 2014 Margaret Wasserman <mrw@painless-security.com> - 1.2-1
- New upstream version.
- Includes constraints, gss-name change and settable port number.

* Fri Dec 20 2013 Sam Hartman <hartmans@debian.org> - 1.0.1-1
- New upstream version

* Wed Nov 20 2013 Sam Hartman <hartmans@debian.org> - 1.0-2
- New release including trustidentity for acceptor

* Thu Jul 18 2013 Mark Donnelly <mark@mark-VirtualBox.painless-security.com> - 1.0-1
- New upstream version, 1.0 release

* Mon May 06 2013 Margaret Wasserman <mrw@painless-security.com> - 0.2.20130506-1
- New upstream version, beta release

* Thu Apr 18 2013 Sam Hartman <hartmans@debian.org> - 0.1.20130418-1
- New upstream version
- Includes trust router and working tids

* Wed Dec 05 2012 Sam Hartman <hartmans@debian.org> - 0.0.20121205
- Initial Release.

